/*
 * Copyright 2019 WeBank
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.webank.wedatasphere.linkis.database.restful.api;

import com.webank.wedatasphere.linkis.database.restful.remote.UserRestfulRemote;
import com.webank.wedatasphere.linkis.server.Message;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
/**
 * Created by shanhuang on 9/13/18.
 */
@Path("/hello")
@Produces("application/json")
@Consumes("application/json")
@Component
public class UserRestfulApi implements UserRestfulRemote {

    @GET
    @Path("hello")
    public Message hello(@Context HttpServletRequest req) {
        return Message.ok("").data("hello", "hello");
    }

}
